//
// Created by philipp on 20.05.18.
//

#include "NetworkingLib/DatagramReceiver.h"
#include <iostream>

void receive(networking::message::DatagramReceiver<std::string>::Ptr & receiver, networking::time::TimePoint & last)
{
    using namespace std::chrono_literals;
    receiver->asyncReceive(
        1s,
        [&](const auto & error, auto & message, const std::string & host, std::uint16_t port)
        {
            if (!error)
            {
                auto now = networking::time::now();
                auto delta = now - last;
                std::cout << "Content: " << message << "\n"
                          << "Delta time: " << std::chrono::duration_cast<std::chrono::milliseconds>(delta).count() << "\n\n";
                last = now;
            }
            else
            {
                std::cout << "TIMEOUT\n";
            }
            receive(receiver, last);
        });
}

int main(int argc, char ** argv)
{
    networking::Networking net;
    auto receiver = networking::message::DatagramReceiver<std::string>::create(net, 10000);
    auto last = networking::time::now();
    receive(receiver, last);

    while (1);
    return 0;
}